<?php

namespace Modules\Lpj\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Modules\Lpj\Models\LaporanExternal;
use Modules\Lpj\Http\Requests\LaporanExternalRequest;
use Modules\Lpj\Models\Permohonan;

class LaporanExternalController extends Controller
{
    public $user;
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $laporanExternals = LaporanExternal::with('permohonan')->paginate(10);
        return view('lpj::laporan_external.index', compact('laporanExternals'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('lpj::laporan_external.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(LaporanExternalRequest $request)
    {
        $validatedData = $request->validated();

        if ($request->hasFile('file_resume')) {
            $validatedData['file_resume'] = $request->file('file_resume')->store('laporan_external/resume', 'public');
        }

        if ($request->hasFile('file_laporan')) {
            $validatedData['file_laporan'] = $request->file('file_laporan')->store('laporan_external/laporan', 'public');
        }

        LaporanExternal::create($validatedData);

        return redirect()->route('laporan-external.index')->with('success', 'Laporan External berhasil ditambahkan.');
    }

    /**
     * Show the specified resource.
     */
    public function show(LaporanExternal $laporanExternal)
    {
        return view('lpj::laporan_external.show', compact('laporanExternal'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(LaporanExternal $laporanExternal)
    {
        $permohonan = Permohonan::find($laporanExternal->permohonan_id);
        return view('lpj::laporan_external.create', compact('laporanExternal','permohonan'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(LaporanExternalRequest $request, LaporanExternal $laporanExternal)
    {
        $validatedData = $request->validated();

        if ($request->hasFile('file_resume')) {
            $validatedData['file_resume'] = $request->file('file_resume')->store('laporan_external/resume', 'public');
        }

        if ($request->hasFile('file_laporan')) {
            $validatedData['file_laporan'] = $request->file('file_laporan')->store('laporan_external/laporan', 'public');
        }

        $laporanExternal->update($validatedData);

        return redirect()->route('laporan-external.index')->with('success', 'Laporan External berhasil diperbarui.');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(LaporanExternal $laporanExternal)
    {
        $laporanExternal->delete();

        return redirect()->route('laporan-external.index')->with('success', 'Laporan External berhasil dihapus.');
    }

    public function dataForDatatables(Request $request)
    {
        if (is_null($this->user) || !$this->user->can('jenis_aset.view')) {
            //abort(403, 'Sorry! You are not allowed to view users.');
        }

        // Retrieve data from the database
        $query = LaporanExternal::query();

        // Apply search filter if provided
        if ($request->has('search') && !empty($request->get('search'))) {
            $search = $request->get('search');
            $query->where(function ($q) use ($search) {
                $q->where('nomor_laporan', 'LIKE', "%$search%")
                  ->orWhere('tanggal_laporan', 'LIKE', "%$search%")
                  ->orWhereHas('permohonan', function($q) use ($search) {
                      $q->where('nomor_permohonan', 'LIKE', "%$search%");
                  })
                  ->orWhere('tgl_final_laporan', 'LIKE', "%$search%")
                  ->orWhere('nilai_pasar', 'LIKE', "%$search%")
                  ->orWhere('indikasi_nilai_likuidasi', 'LIKE', "%$search%")
                  ->orWhere('indikasi_nilai_pasar_tanah', 'LIKE', "%$search%")
                  ->orWhere('estimasi_harga_tanah', 'LIKE', "%$search%")
                  ->orWhere('estimasi_harga_bangunan', 'LIKE', "%$search%")
                  ->orWhere('indikasi_nilai_pasar_bangunan', 'LIKE', "%$search%")
                  ->orWhere('indikasi_nilai_pasar_sarana_pelengkap', 'LIKE', "%$search%")
                  ->orWhere('indikasi_nilai_pasar_mesin', 'LIKE', "%$search%")
                  ->orWhere('indikasi_nilai_pasar_kendaraan_alat_berat', 'LIKE', "%$search%")
                  ->orWhere('file_resume', 'LIKE', "%$search%")
                  ->orWhere('file_laporan', 'LIKE', "%$search%");
            });
        }

        // Apply sorting if provided
        if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        // Get the total count of records
        $totalRecords = $query->count();

        // Apply pagination if provided
        if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->with(['permohonan.debiture','permohonan.penawaran.tujuanPenilaianKjpp','permohonan.dokumenjaminan.jenisjaminan'])->get();

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = 0 + 1;

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data,
        ]);
    }
}
